# React Router &middot; [![npm package][npm-badge]][npm] [![Travis][build-badge]][build]

[npm-badge]: https://img.shields.io/npm/v/history.svg?style=flat-square
[npm]: https://www.npmjs.org/package/react-router
[build-badge]: https://img.shields.io/travis/ReactTraining/react-router/dev.svg?style=flat-square
[build]: https://travis-ci.com/ReactTraining/react-router

React Router is a lightweight, fully-featured routing library for the
[React](https://reactjs.org) JavaScript library. React Router runs everywhere
that React runs; on the web, on the server (using node.js), and on React Native.

If you're reading this, you're on the dev branch where we are actively
developing the next major version of React Router, version 6. We're really
excited about v6 and believe it delivers a lot of improvements over v5, but we
do not yet recommend it for use in production. Please wait until we have a
stable release before deploying it on your production app.

If you're new to React Router, we recommend you start with [the getting started
guide](/docs/guides/getting-started.md).

If you're migrating to v6 from v5 (or v4, which is the same as v5), check out
[the migration guide](/docs/guides/migrating-5-to-6.md).

When v6 is stable we will publish the docs on our website.

## Contributing

There are many different ways to contribute to React Router's development. If
you're interested, check out [our contributing guidelines](CONTRIBUTING.md) to
learn how you can get involved.

## Packages

This repository is a monorepo containing the following packages:

- [`react-router`](/packages/react-router)
- [`react-router-dom`](/packages/react-router-dom)
- [`react-router-native`](/packages/react-router-native)

## Changes

Detailed release notes for a given version can be found [on our releases
page](https://github.com/ReactTraining/react-router/releases).

## Funding

You may provide financial support for this project by donating [via Open
Collective](https://opencollective.com/react-router), attending [one of our
workshops](https://reacttraining.com/workshops/), or purchasing [one of our
online courses](https://reacttraining.com/courses/). Thank you for your support!

## About

`react-router` is developed and maintained by [React
Training](https://reacttraining.com) and many [amazing
contributors](https://github.com/ReactTraining/react-router/graphs/contributors).
If you're interested in learning more about what React can do for your company,
please [get in touch](mailto:hello@reacttraining.com)!
